import { SchemeColor } from './models';

export type ColorSetVariant = {
  chroma: number;
  lightness: number;
};

export type Settings = {
  hover: ColorSetVariant;
  active: ColorSetVariant;
  focus: ColorSetVariant;
  disabled: ColorSetVariant;
  foregroundRange: [SchemeColor, SchemeColor];
  foregroundGeneration: 'fixed' | 'wacg_atuo';
};

export type SchemeSet = {
  primary: SchemeColor;
  onPrimary: SchemeColor;
  secondary: SchemeColor;
  onSecondary: SchemeColor;
  accent: SchemeColor;
  onAccent: SchemeColor;
  neutral: SchemeColor;
  onNeutral: SchemeColor;
  danger: SchemeColor;
  onDanger: SchemeColor;
  warning: SchemeColor;
  onWarning: SchemeColor;
  success: SchemeColor;
  onSuccess: SchemeColor;
  info: SchemeColor;
  onInfo: SchemeColor;
  border: SchemeColor;
  lightenBorder: SchemeColor;
  elevation: SchemeColor;
  background: SchemeColor;
  onBackground: SchemeColor;
  inverseBackground: SchemeColor;
  onInverseBackground: SchemeColor;
};

export type ColorQScheme = {
  scheme: SchemeSet;
  setting: Settings;
};
